#ifndef __NS_MATH_H
#define __NS_MATH_H

#define NSM_LOGFILENAME "/tmp/ns_math.log"

#define NSM_USAGE "usage:\n"\
 "   NetSolve[FuncName[arg1, ...]]   - blocking problem call\n"\
 "   NetSolveNB[FuncName[arg1, ...]] - nonblocking problem call\n"\
 "   NetSolveProbe[request]          - checks if a request is completed\n"\
 "   NetSolveWait[request]           - waits for a request to complete\n"\
 "   NetSolveGetAgent[]              - returns the current agent name\n"\
 "   NetSolveSetAgent[AgentName]     - changes the agent we are working with\n"\
 "   NetSolveError[]                 - returns the result code of the last\n"\
 "                                       executed NetSolve function\n"\
 "   NetSolveErrorMsg[rc]            - returns a string describing\n"\
 "                                       the result code passed\n"\
 "   NetSolve[\\\"?problems\\\"]           - shows a list of available problems\n"\
 "   NetSolve[\\\"?servers\\\"]            - shows a list of available servers\n"\
 "   NetSolve[\\\"?FuncName[]\\\"]         - shows a problem description"

#ifndef LOGLEVEL
#define LOGLEVEL 5
#endif

#define NETSOLVE_AGENT "NETSOLVE_AGENT"

int nsmath_send_problem();
void nsmath_get_wait_result();
extern int ns_error;
   
#endif   
   
