/*
 * Netsolve global utility definitions
 */
#ifdef NETSOLVE_GLOBAL_H
#else
#define NETSOLVE_GLOBAL_H 1

#define ERR_ABORT(a) \
    if (a) {printf("Error in line %d of file %s.\n",__LINE__,__FILE__); \
            return a;}
#define ERR_RETURN(a) \
    if (a) {printf("Error in line %d of file %s.\n",__LINE__,__FILE__); \
            return a;}
#define ERR_REPORT(a) \
    {printf("Error in line %d of file %s:\n  %s\n",__LINE__,__FILE__,a); \
     return 1;}
#define ERR_REPORTi(a,b) \
    {printf("Error in line %d of file %s:\n  %s: %d\n", \
	    __LINE__,__FILE__,a,b); \
     return 1;}
#define ERR_REPORTii(a,b,c) \
    {printf("Error in line %d of file %s:\n  %s: %d,%d\n", \
	    __LINE__,__FILE__,a,b,c); \
     return 1;}
#define ERR_REPORTiii(a,b,c,d) \
    {printf("Error in line %d of file %s:\n  %s: %d,%d\n", \
	    __LINE__,__FILE__,a,b,c,d); \
     return 1;}
#define OVERFLOW_REPORT(a,b,c,d) \
    {printf("Error in line %d of file %s:\n  %s\n  index %d outside %d-%d\n",\
            __LINE__,__FILE__,a,b,c,d); \
     return 1;}

#endif
